// DlgEffects.cpp :  Դϴ.
//

#include "stdafx.h"
#include "Test_TextEffects.h"
#include "DlgEffects.h"


// CDlgEffects ȭ Դϴ.

IMPLEMENT_DYNAMIC(CDlgEffects, CDialog)

CDlgEffects::CDlgEffects(CWnd* pParent /*=NULL*/)
	: CDialog(CDlgEffects::IDD, pParent)
	, m_bOutline(FALSE)
	, m_nOutlineWidth(1)
	, m_bShadow(FALSE)
	, m_nShadowOffset(2)
	, m_colorText(RGB(0,0,0))
	, m_colorBack(RGB(255,255,255))
	, m_colorShadow(RGB(0xc0,0xc0,0xc0))
	, m_nOutlineMode(0)
{

}

CDlgEffects::~CDlgEffects()
{
}

void CDlgEffects::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_CB_COLOR_TEXT, m_ctrlCBColorText);
	DDX_Control(pDX, IDC_CB_COLOR_BACK, m_ctrlCBColorBack);
	DDX_Check(pDX, IDC_CHECK_OUTLINE, m_bOutline);
	DDX_Control(pDX, IDC_EDIT_OUTLINEWIDTH, m_editOutlineWidth);
	DDX_Text(pDX, IDC_EDIT_OUTLINEWIDTH, m_nOutlineWidth);
	DDX_Check(pDX, IDC_CHECK_SHADOW, m_bShadow);
	DDX_Control(pDX, IDC_EDIT_SHADOWOFFSET, m_editShadowOffset);
	DDX_Text(pDX, IDC_EDIT_SHADOWOFFSET, m_nShadowOffset);
	DDX_Control(pDX, IDC_CB_COLOR_SHADOW, m_ctrlCBColorShadow);
	DDX_Control(pDX, IDC_STATIC_MAINGROUP, m_staticMainGroup);
	DDX_Control(pDX, IDC_CHECK_OUTLINE, m_checkOutline);
	DDX_Control(pDX, IDC_CHECK_SHADOW, m_checkShadow);
	DDX_Control(pDX, IDC_SPIN_OUTLINEWIDTH, m_spinOutlineWidth);
	DDX_Control(pDX, IDC_SPIN_SHADOWOFFSET, m_spinShadowOffset);
	DDX_Control(pDX, IDC_CB_OUTLINEMODE, m_cbOutlineMode);
	DDX_CBIndex(pDX, IDC_CB_OUTLINEMODE, m_nOutlineMode);
}


BEGIN_MESSAGE_MAP(CDlgEffects, CDialog)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_CHECK_OUTLINE, &CDlgEffects::OnBnClickedCheckOutline)
	ON_BN_CLICKED(IDC_CHECK_SHADOW, &CDlgEffects::OnBnClickedCheckShadow)
	ON_CBN_SELCHANGE(IDC_CB_COLOR_TEXT, &CDlgEffects::OnCbnSelchangeCbColorText)
	ON_CBN_SELCHANGE(IDC_CB_COLOR_BACK, &CDlgEffects::OnCbnSelchangeCbColorBack)
	ON_EN_CHANGE(IDC_EDIT_OUTLINEWIDTH, &CDlgEffects::OnEnChangeEditOutlinewidth)
	ON_EN_CHANGE(IDC_EDIT_SHADOWOFFSET, &CDlgEffects::OnEnChangeEditShadowoffset)
	ON_CBN_SELCHANGE(IDC_CB_COLOR_SHADOW, &CDlgEffects::OnCbnSelchangeCbColorShadow)
	ON_CBN_SELCHANGE(IDC_CB_OUTLINEMODE, &CDlgEffects::OnCbnSelchangeCbOutlinemode)
END_MESSAGE_MAP()


// CDlgEffects ޽ óԴϴ.

BOOL CDlgEffects::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  ⿡ ߰ ʱȭ ۾ ߰մϴ.
	//////////////////////////////////////////////////////////////////////////
	// Ʈ ʱȭ
	InitControls();
	EnableControls();

	return TRUE;  // return TRUE unless you set the focus to a control
	// : OCX Ӽ  FALSE ȯؾ մϴ.
}

void CDlgEffects::InitControls()
{
	m_ctrlCBColorText.InitializeDefaultColors();
	m_ctrlCBColorText.SetSelectedColorValue(m_colorText);
	m_ctrlCBColorBack.InitializeDefaultColors();
	m_ctrlCBColorBack.SetSelectedColorValue(m_colorBack);
	m_ctrlCBColorShadow.InitializeDefaultColors();
	m_ctrlCBColorShadow.SetSelectedColorValue(m_colorShadow);

	CString sItems[] = {_T("ǥ̵"), _T("GDI Path"), _T("GDI+ Path"), _T("")};
	int i = 0;
	while (0 != sItems[i].GetLength())
	{
		m_cbOutlineMode.AddString(sItems[i++]);
	}
	m_cbOutlineMode.SetCurSel(0);
	m_spinOutlineWidth.SetRange(1, 20);
	m_spinShadowOffset.SetRange(-20, 20);
}

void CDlgEffects::OnSize(UINT nType, int cx, int cy)
{
	CDialog::OnSize(nType, cx, cy);

	// TODO: ⿡ ޽ ó ڵ带 ߰մϴ.
	if (m_staticMainGroup.GetSafeHwnd())
	{
		m_staticMainGroup.MoveWindow(0,0,cx,cy);
	}
}

void CDlgEffects::OnBnClickedCheckOutline()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	EnableControls();
	GetParent()->SendMessage(TB_OUTLINE, (WPARAM)(BST_CHECKED == m_checkOutline.GetCheck()), 0);
}

void CDlgEffects::OnBnClickedCheckShadow()
{
	// TODO: ⿡ Ʈ ˸ ó ڵ带 ߰մϴ.
	EnableControls();
	GetParent()->SendMessage(TB_SHADOW, (WPARAM)(BST_CHECKED == m_checkShadow.GetCheck()), 0);
}

void CDlgEffects::EnableControls()
{
	m_editOutlineWidth.EnableWindow(BST_CHECKED == m_checkOutline.GetCheck());
	m_editShadowOffset.EnableWindow(BST_CHECKED == m_checkShadow.GetCheck());
	m_ctrlCBColorShadow.EnableWindow(BST_CHECKED == m_checkShadow.GetCheck());
}

void CDlgEffects::OnCbnSelchangeCbColorText()
{
	GetParent()->SendMessage(TB_COLORTEXT, (WPARAM)m_ctrlCBColorText.GetSelectedColorValue(), 0);
}

void CDlgEffects::OnCbnSelchangeCbColorBack()
{
	GetParent()->SendMessage(TB_COLORBACK, (WPARAM)m_ctrlCBColorBack.GetSelectedColorValue(), 0);
}

void CDlgEffects::OnEnChangeEditOutlinewidth()
{
	if (m_editOutlineWidth.GetSafeHwnd())
	{
		UpdateData(TRUE);
		GetParent()->SendMessage(TB_OUTLINEWIDTH, (WPARAM)m_nOutlineWidth, 0);
	}
}

void CDlgEffects::OnEnChangeEditShadowoffset()
{
	if (m_editShadowOffset.GetSafeHwnd())
	{
		UpdateData(TRUE);
		GetParent()->SendMessage(TB_SHADOWOFFSET, (WPARAM)m_nShadowOffset, 0);
	}
}

void CDlgEffects::OnCbnSelchangeCbColorShadow()
{
	GetParent()->SendMessage(TB_SHADOWCOLOR, (WPARAM)m_ctrlCBColorShadow.GetSelectedColorValue(), 0);
}

void CDlgEffects::OnCbnSelchangeCbOutlinemode()
{
	if (m_cbOutlineMode.GetSafeHwnd())
	{
		UpdateData(TRUE);
		GetParent()->SendMessage(TB_OUTLINEMODE, (WPARAM)m_nOutlineMode, 0);
	}
}
